package es.ua.dlsi.prog3.exceptions.mains;

import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Date;

import es.ua.dlsi.prog3.exceptions.FileUtilitiesV2;
/**
 * @author David Rizo
 */
public class FileUtilitiesAppV2 {
	public static final void main(String [] args) {
		if (args.length < 1) {
			System.err.println("Missing command");
		} else {
			switch (args[0]) {
				case "-checkexistsfile":
					if (args.length != 3) {
						System.err.println("Use: FileUtilitiesApp -checkexistsfile <folder name> <file name>");
					} else {
						FileUtilitiesV2 fu = new FileUtilitiesV2();
						File file = fu.getFileInDirectory(args[1], args[2], false);
						switch (FileUtilitiesV2.lastError) {
						case none:
							System.out.println("File exists");
							break;
						case eFolderNotExists:
							System.out.println("Folder does not exist");
							break;
							//....
						}
					}
					break;
				case "-createblankfile":
					if (args.length != 3) {
						System.err.println("Use: FileUtilitiesApp -createblankfile <folder name> <file name>");
					} else {
						FileUtilitiesV2 fu = new FileUtilitiesV2();
						File folder = fu.getDirectory(args[1]);
						if (folder == null) {
							/** note how we are checking this condition twice, here and inside getDirectory **/
							System.out.println("Folder does not exist"); 
						} else {
							File file = new File(folder, args[2]);
							try {
								file.createNewFile();
								PrintStream ps = new PrintStream(file);
								ps.println("File created @ PROG3: "+ new Date());
								ps.close();
							} catch (Exception e) {
								// TODO Auto-generated catch block
								System.out.println("Folder does not exist"); 
							}
						}						
					}		
					break;
				default: 
					System.err.println("Unknown command!");

			}
		}
	}
}
