package es.ua.dlsi.prog3.exceptions.mains;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Date;

import es.ua.dlsi.prog3.exceptions.FileUtilitiesV4;
/**
 * @author David Rizo
 */
public class FileUtilitiesAppV4 {
	public static final void main(String [] args) {
		if (args.length < 1) {
			System.err.println("Missing command");
		} else {
			switch (args[0]) {
				case "-checkexistsfile":
					if (args.length != 3) {
						System.err.println("Use: FileUtilitiesApp -checkexistsfile <folder name> <file name>");
					} else {
						FileUtilitiesV4 fu = new FileUtilitiesV4();
						File file;
						try {
							file = fu.getFileInDirectory(args[1], args[2], false);
							System.out.println("File exists");
						} catch (FileNotFoundException e) {
							System.out.println("File does not exist: " + e.getMessage());
							
						} catch (Exception e) {
							System.out.println("Error: " + e.getMessage());
						}
					}
					break;
				case "-createblankfile":
					if (args.length != 3) {
						System.err.println("Use: FileUtilitiesApp -createblankfile <folder name> <file name>");
					} else {
						FileUtilitiesV4 fu = new FileUtilitiesV4();
						File file = null;
						try {
							file = fu.getFileInDirectory(args[1], args[2], true);
							file.createNewFile();
							
							PrintStream ps = new PrintStream(file);
							ps.println("File created @ PROG3: " + new Date());
							ps.close();								
							
						} catch (Exception e1) {
							System.err.println("No se ha podido obtener el fichero: " + e1.getMessage());
						}
					}					
			}
		}
	}
}
