package es.ua.dlsi.prog3.exceptions.mains;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Date;

import es.ua.dlsi.prog3.exceptions.FileUtilitiesV5;
import es.ua.dlsi.prog3.exceptions.NotAFileException;
/**
 * @author David Rizo
 */
public class FileUtilitiesAppV5 {
	public static final void main(String [] args) throws NotAFileException  {
		if (args.length < 1) {
			System.err.println("Missing command");
		} else {
			switch (args[0]) {
				case "-checkexistsfile":
					if (args.length != 3) {
						System.err.println("Use: FileUtilitiesApp -checkexistsfile <folder name> <file name>");
					} else {
						FileUtilitiesV5 fu = new FileUtilitiesV5();
						File file;
						try {
							file = fu.getFileInDirectory(args[1], args[2], false);
							System.out.println("File exists");
						} catch (NotAFileException ex) {
							System.out.println(ex.getMessage());
							throw new NullPointerException(ex.getMessage());
						} catch (FileNotFoundException e) {
							System.out.println("File does not exist: " + e.getMessage());
							throw new NotAFileException("", "");
						} catch (Exception e) {
							System.out.println("Error occurred: " + e.getMessage());
						}
					}
					break;
				case "-createblankfile":
					if (args.length != 3) {
						System.err.println("Use: FileUtilitiesApp -createblankfile <folder name> <file name>");
					} else {
						FileUtilitiesV5 fu = new FileUtilitiesV5();
						File file = null;
						try {
							file = fu.getFileInDirectory(args[1], args[2], true);
							file.createNewFile();
							
							PrintStream ps = new PrintStream(file);
							ps.println("File created @ PROG3: " + new Date());
							ps.close();															
						} catch (FileNotFoundException e) {
							System.err.println("File or folder cannot be found: " + e.getMessage());
						} catch (Exception e) {
							System.err.println("Cannot write file: " + e.getMessage());
						}
					}					
			}
		}
	}
}
