package es.ua.dlsi.prog3.exceptions.mains;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Date;

import es.ua.dlsi.prog3.exceptions.FileNotWriteableException;
import es.ua.dlsi.prog3.exceptions.FileUtilitiesV8;
import es.ua.dlsi.prog3.exceptions.NotAFileException;
import es.ua.dlsi.prog3.exceptions.NotAFolderException;
/**
 * @author David Rizo
 */
public class FileUtilitiesAppV8 {
	public static final void main(String [] args) {
		if (args.length < 1) {
			System.err.println("Missing command");
		} else {
			switch (args[0]) {
				case "-checkexistsfile":
					if (args.length != 3) {
						System.err.println("Use: FileUtilitiesApp -checkexistsfile <folder name> <file name>");
					} else {
						FileUtilitiesV8 fu = new FileUtilitiesV8();
						File file;
						try {
							file = fu.getFileInDirectory(args[1], args[2], false);
							System.out.println("File exists");
						} catch (FileNotFoundException e) {
							System.out.println("File does not exist: " + e.getMessage());
						} catch (Exception e) {
							System.out.println("Error occurred: " + e.getMessage());
						}
					}
					break;
				case "-createblankfile":					
					if (args.length != 3) {
						System.err.println("Use: FileUtilitiesApp -createblankfile <folder name> <file name>");
					} else {
						FileUtilitiesV8 fu = new FileUtilitiesV8();
						try {
							fu.createBlankFile(args[1], args[2], "File created @ PROG3: " + new Date());
						} catch (FileNotFoundException e) {
							System.err.println("El directorio " + args[1] + " no existe");
						} catch (NotAFolderException e) {
							System.err.println(args[1] + " no es un directorio");
						} catch (NotAFileException e) {
							System.err.println(args[2] + " no es un fichero, es posible que sea un directorio");
						} catch (FileNotWriteableException e) {
							System.err.println(args[2] + " no tiene permisos de escritura");
						} 					
					}					
			}
		}
	}
}
