package es.ua.dlsi.prog3.exceptions.pilaEnteros;

/**
 * Ejercicio: Crea una ExcepcionDesbordamiento que se lance cuando
 * se desborde la pila.
 * @author pierre
 */
public class PilaEnteros {
	/**
	 * Tamaño máximo de la pila
	 */
	private int maximo; 
	/**
	 * La pila
	 */
	private int[] pila;
	/**
	 * número de elementos actualmente en la pila-1
	 */
	private int cima; 

	/**
	 * Crea una pila que puede albergar como máximo 'max' elementos.
	 * Si 'max' es negativo, la pila se crea con tamaño cero.
	 * @param max tamaño máximo de la pila
	 */
	public PilaEnteros(int max) { 
		if (max>=0) maximo = max; else maximo = 0; 
		pila = new int[max]; 
		cima = -1;
	}

	/**
	 * Apila un entero en la pila
	 * @param elem entero a apilar
	 */
	void apilar (int elem)  {
			if (cima  < maximo-1) {
				pila[++cima]= elem;
				System.out.println("Apilo"+elem);
			} // sino no apila nada ni notifica a nadie
	}

	/**
	 * Programa principal que intenta apilar 20 eneteros en una pila
	 * donde sólo caben 5.
	 * @param args no se usa
	 */
	public static final void main(String args[]){
		PilaEnteros pi = new PilaEnteros(5);
		for (int i=0;i<20;i++)
			pi.apilar(i);
	}
	
}