package es.ua.dlsi.prog3.exceptions.simple;

import java.util.*;


public class  UD3_4_LanzarExcepcion {
	/** 
	 * Función que detecta un error y lanza una excepción. 
	 * No trata el error. Eso lo hace el código cliente, que sabe en qué contexto
	 * se ha llamado a f().
	 * 
	 * Fíjate en la cláusula 'throws' tras la lista de argumentos. 
	 * Es necesario indicarla cuando lanzamos excepciones declaradas (checked exceptions)
	 *
	 * Esta función solo admite números positivos o cero...
	 * @param a un número positivo
	 * @return a+1 
	 * @throws Exception si a no es positivo 
	 */ 
    static int f(int a) throws Exception {
    	
        if (a<0) // error
        		throw new Exception("Número negativo"); // salimos de la función en estado de error
    
        return a+1; // salimos de la función de forma normal
    
    }
    
    public static void main(String args[]) {
        int x = 10;
        
	        try {
	        	int r = f(-x); // o f(-x);
	        	
	        	// código protegido a partir de aquí
				System.out.println("x = "+x+" f(x)= "+r);
	        
	        } catch (Exception ex) {
		        System.err.println(ex.getMessage());
		        ex.printStackTrace();    
	        }
        
        System.out.println("FIN");
		// Moraleja:
		// 1. Ya no hay código spaguetti: el código de manejo de errores está separado del
		//  código normal.
		// 2. El código cliente está obligado a comprobar que se ha producido un error (try/catch)
        //    Si no, el programa abortará.
		// 3. El tratamiento de errores mediante excepciones es estándar en Java
    }
}