package es.ua.dlsi.prog3.exceptions.simple;

import java.util.*;


public class  UD3_5_LanzarExcepcion_2 {
	/** 
	 * Función que detecta un error y lanza excepciones. 
	 * No trata los errores. Eso lo hace el código cliente, que sabe en qué contexto
	 * se ha llamado a f().
	 * 
	 * Fíjate en la cláusula 'throws' tras la lista de argumentos. 
	 * Es necesario indicarla cuando lanzamos excepciones declaradas (checked exceptions)
	 *
	 * Esta función solo admite números positivos entre cero y 100 ...
	 * @param a un número positivo entre 0 y 100
	 * @return a+1 
	 * @throws Exception si a no es positivo o es mayor que 100
	 */ 
    static int f(int a) throws Exception {
        if (a<0 || a>100) // error
        		throw new Exception("Número negativo o mayor que 100");
        return a+1;
    }
    
    public static void main(String args[]) {
        int x = 10;
        
        try {
        	int r = f(x); // o f(-x);
			System.out.println("x = "+x+" f(x)= "+r);
			
        } catch (Exception ex) {
	        System.err.println(ex.getMessage());
	        // Problema: no podemos saber dentro de este catch cual ha sido el error
	        // ¿Era el número negativo o mayor que 100?
        }
    }
}