package es.ua.dlsi.prog3.exceptions.simple;


public class  UD3_8_TryCatchFinally {
	

	/** 
	 * Función que detecta un error y lanza excepciones. 
	 * No trata los errores. Eso lo hace el código cliente, que sabe en qué contexto
	 * se ha llamado a f().
	 * 
	 * Esta función solo admite números positivos entre cero y 100 ...
	 * @param a un número positivo entre 0 y 100
	 * @return a+1 
	 * @throws ExcepcionNumeroNegativo si a no es positivo
	 * @throws ExcepcionNumeroMuyGrande si a es mayor que 100
	 */ 
    static int f(int a) throws ExcepcionNumeroNegativo, ExcepcionNumeroMuyGrande {
        if (a<0) 
        		throw new ExcepcionNumeroNegativo(a);
        else if (a>100)
        		throw new ExcepcionNumeroMuyGrande("Número mayor que 100");
        
        return a+1;
    }
    
    public static void main(String args[]) {
 
    	int x = 10000;
        
        // Múltiples catch, uno para cada tipo de excepción
        try {
        		int r = f(x); // o f(-x);
			System.out.println("x = "+x+" f(x)= "+r);
        } catch (ExcepcionNumeroNegativo ex) {
	        System.err.println(ex.getMessage());
        } catch (ExcepcionNumeroMuyGrande ex) {
	        System.err.println(ex.getMessage());
	        System.exit(-1);
        } finally {
        		System.out.println("Fin de la historia.");
        }
        
        System.out.println("FIN");
        
        
   }
}