package es.ua.dlsi.prog3.exceptions.simple;


public class  UD3_9b_RelanzamientoDeExcepciones {
	
	/** 
	 * Esta función solo admite números positivos 
	 * @param a un número positivo
	 * @return a 
	 * @throws ExcepcionNumeroNegativo si a no es positivo
	 */ 
	static int g(int a) throws ExcepcionNumeroNegativo {
		if (a<0) 
			throw new ExcepcionNumeroNegativo(a);
		return a;
	}

	/** 
	 * Esta función solo admite números positivos entre cero y 100 ...
	 * 
	 * Relanza la excepcion ExcepcionNumeroNegativo de forma implícita
	 * @param a un número positivo entre 0 y 100
	 * @return a+1 
	 * @throws ExcepcionNumeroNegativo si a no es positivo
	 * @throws ExcepcionNumeroMuyGrande si a es mayor que 100
	 */ 
    static int f1(int a) throws ExcepcionNumeroNegativo, ExcepcionNumeroMuyGrande {
    		g(a);
    		if (a>100)
        		throw new ExcepcionNumeroMuyGrande("Número mayor que 100");
        	return a+1;
    }
    
	/** 
	 * Esta función solo admite números positivos entre cero y 100 ...
	 * 
	 * Captura y relanza la excepcion ExcepcionNumeroNegativo 
	 * @param a un número positivo entre 0 y 100
	 * @return a+1 
	 * @throws ExcepcionNumeroNegativo si a no es positivo
	 * @throws ExcepcionNumeroMuyGrande si a es mayor que 100
	 */ 
    static int f2(int a) throws ExcepcionNumeroNegativo, ExcepcionNumeroMuyGrande {
    		try {
    			g(a);
    		} catch (ExcepcionNumeroNegativo ex) {
    			// Puedo hacer algo aquí antes de relanzar
    			System.out.println("Algo está pasando...");
    			throw ex;
    		}
    		if (a>100)
        		throw new ExcepcionNumeroMuyGrande("Número mayor que 100");
        	return a+1;
    }
    
	/** 
	 * Esta función solo admite números positivos entre cero y 100 ...
	 * 
	 * Captura ExcepcionNumeroNegativo y relanza otra distinta 
	 * @param a un número positivo entre 0 y 100
	 * @return a+1 
	 * @throws ExcepcionNumeroNegativo si a no es positivo
	 * @throws ExcepcionNumeroMuyGrande si a es mayor que 100
	 */ 
    static int f3(int a) throws  ExcepcionNumeroMuyGrande /* ExcepcionNumeroNegativo ya no se lanza */ 
    {
    		try {
    			g(a);
    		} catch (ExcepcionNumeroNegativo ex) {
    			// Puedo hacer algo aquí antes de relanzar
    			System.out.println("Algo está pasando...");
    			throw new ArithmeticException(ex.getMessage());
    		}
    		if (a>100)
        		throw new ExcepcionNumeroMuyGrande("Número mayor que 100");
        	return a+1;
    }
    
    public static void main(String args[]) {
        int x = 10;
        
        // Múltiples catch, uno para cada tipo de excepción
        try {
        		int r = f1(-x); // o f(-x);
			System.out.println("x = "+x+" f(x)= "+r);
        } catch (ExcepcionNumeroNegativo ex) {
	        System.err.println(ex.getMessage());
        } catch (ExcepcionNumeroMuyGrande ex) {
	        System.err.println(ex.getMessage());
        }

        // Múltiples catch, uno para cada tipo de excepción
        try {
        		int r = f2(x+100); // o f(-x);
			System.out.println("x = "+x+" f(x)= "+r);
        } catch (ExcepcionNumeroNegativo ex) {
	        System.err.println(ex.getMessage());
        } catch (ExcepcionNumeroMuyGrande ex) {
	        System.err.println(ex.getMessage());
        }

        // Múltiples catch, uno para cada tipo de excepción
        try {
        		int r = f3(-x); // o f(-x);
			System.out.println("x = "+x+" f(x)= "+r);
        } catch (ArithmeticException ex) {
	        System.err.println(ex.getMessage());
        } catch (ExcepcionNumeroMuyGrande ex) {
	        System.err.println(ex.getMessage());
        }

   }
}