package es.ua.dlsi.prog3.frameworks.carreras.formula1;

import java.util.Random;

import es.ua.dlsi.prog3.frameworks.carreras.Circuito;

/** 
 * Programa principal que crea un circuito con 5 vehículos participantes
 * que pueden ser coches o camiones de formula 1, elegidos al azar
 * La carrera es a 7 vueltas.
 * @author pierre
 *
 */
public class CarreraFormula1 {

	/**
	 * Programa principal
	 * @param args no se usa
	 */
	public static void main(String[] args) {
		int MAXCOCHES = 5;

		Circuito c = new Circuito("Valencia");
		SafetyCar sc = new SafetyCar ("BMW");

		c.add_safetycar (sc);

		System.out.println("Simulador de carreras");
		  for (int n = 0; n < MAXCOCHES; n++) {
			    int rn = (new Random()).nextInt(100);
			    if (rn < 50) { // Formula1
			      String marca = "HRT"+n;
			      c.add_vehiculo (new Formula1(marca));
			    } else {
			      String marca = "RENAULT"+n;
			      c.add_vehiculo (new CamionFormula1 (marca));
			    }
			  }
			  c.simular_carrera (7);
			} // fin main


}
