package es.ua.dlsi.prog3.frameworks.carreras.formula1;

import es.ua.dlsi.prog3.frameworks.carreras.ICocheAuxiliar;

/**
 * Coche auxiliar para una carrera 
 * @author pierre
 *
 */
public class SafetyCar extends Coche implements ICocheAuxiliar {

	/**
	 * Construye el coche auxiliar situado inicialmente fuera de la pista.
	 * @param marca marca del coche
	 */
	public SafetyCar (String marca) {
		super (marca);
		m_en_pista = false;
	}
	
	/* (non-Javadoc)
	 * @see es.ua.dlsi.prog3.frameworks.carreras.ICocheAuxiliar#en_pista()
	 */
	@Override
	public boolean en_pista () { return m_en_pista;}
	
	/* (non-Javadoc)
	 * @see es.ua.dlsi.prog3.frameworks.carreras.ICocheAuxiliar#toggle()
	 */
	@Override
	public void toggle () { m_en_pista = !m_en_pista;}
	
	/**
	 * Coloca el coche dentro o fuera de la pista
	 * @param v si es true, coloca el coche en pista
	 */
	public void set_en_pista (boolean v)
	 { m_en_pista = v; }

	/**
	 * Situación del vehículo. 
	 * true: en pista
	 * false: fuera de pista
	 */
	private boolean m_en_pista;

}
