/**
 * 
 */
package es.ua.dlsi.prog3.frameworks.jcf;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * Demostración de las principales clases y operaciones
 * del Java Collections Framework
 * @author pierre
 *
 */
public class GuiaFacilJCF {

	/**
	 * 
	 */
	public GuiaFacilJCF() {
		// TODO Auto-generated constructor stub
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// Lista de enteros. Puede haber enteros repetidos en la lista:
		List<Integer> lista_de_manzanas;  

		// Conjunto de enteros. No puede haber enteros repetidos:
		Set<Integer> conjunto_de_naranjas;

		// Un mapa que asocia a una cadena un entero, como en una lista de notas de un examen:
		//		    [("Juan Goytisolo", 9.5), ("Pablo Iglesias", 5.0), ...]
		Map<String, Integer> mapa_de_notas;

		// LISTAS
		// Creación
		List<Integer> lista_de_enteros = new ArrayList<Integer>();
		// Añadir elementos
		lista_de_enteros.add(new Integer(4));
		lista_de_enteros.add(new Integer(5));
		lista_de_enteros.add(new Integer(7));
		lista_de_enteros.add(2,new Integer(6)); // lo añade en la posición 2, entre el 5 y el 7
		// Tamaño de la lista
		lista_de_enteros.size();
		// Obtener elementos
		Integer primero = lista_de_enteros.get(0);
		Integer ultimo = lista_de_enteros.get(lista_de_enteros.size()-1);
		// Preguntar si contiene un elemento
		lista_de_enteros.contains(new Integer(7)); // me devolverá 'true'
		lista_de_enteros.contains(new Integer(8)); // me devolverá 'false'
		// Obtener posición de un elemento
		lista_de_enteros.indexOf(new Integer(6)); // devuelve 2
		lista_de_enteros.indexOf(new Integer(10)); // devuelve -1
		
		// Recorrer la lista. Compara los diferentes bucles
		// Bucle 1: toda la lista
		for (Integer entero : lista_de_enteros) {
			  System.out.println(entero);
		}
		// Bucle 2: hasta la posición que me interese
		for (int i=0; i < lista_de_enteros.size(); i++) {
			  System.out.println(lista_de_enteros.get(i));			
		}
		// Bucle 3: hasta el elemento que me interese
		Iterator<Integer> it = lista_de_enteros.iterator();
		while(it.hasNext()) {
			Integer x = it.next();
			System.out.println(x);			
		}
		
		// Eliminar un elemento
		boolean quitado = lista_de_enteros.remove(new Integer(7)); // quita el primer 7
		Integer unEntero = lista_de_enteros.remove(1); // quita el segundo elemento
		// Preguntar si la lista está vacía o vaciarla
		boolean estaVacia = lista_de_enteros.isEmpty(); // devolverá 'false'
		lista_de_enteros.clear(); // ahora sí que está vacía

		// CONJUNTOS
		Set<Integer> conjunto_de_enteros = new HashSet<Integer>();

		// Añadir elementos
		conjunto_de_enteros.add(new Integer(4));
		conjunto_de_enteros.add(new Integer(5));
		conjunto_de_enteros.add(new Integer(7));
		boolean repe = conjunto_de_enteros.add(new Integer(4));
		// no añade el 4 porque ya está en el conjunto y además devuelve 'false'

		// Tamaño
		conjunto_de_enteros.size();
		// Función 'pertenece'
		conjunto_de_enteros.contains(new Integer(7)); // me devolverá 'true'
		conjunto_de_enteros.contains(new Integer(8)); // me devolverá 'false'

		// Recorrer un conjunto
		for (Integer entero : conjunto_de_enteros) {
			  System.out.println(entero);
		}
		Iterator<Integer> itc = conjunto_de_enteros.iterator();
		while (itc.hasNext()) {
			Integer x = itc.next();
			System.out.println(x);			
		}

		// Eliminar un elemento del conjunto
		boolean quitado2 = conjunto_de_enteros.remove(new Integer(7)); // quita el 7
		// Preguntar si el conjunto está vacío o vaciarlo
		boolean estaVacio = conjunto_de_enteros.isEmpty(); // devolverá 'false'
		conjunto_de_enteros.clear(); // ahora sí que está vacío

		// Listas y conjuntos == colecciones
		Collection<Integer> coleccion = lista_de_enteros;
		// añado un entero a la lista
		coleccion.add(new Integer(10));

		coleccion = conjunto_de_enteros;
		// añado un entero al conjunto
		coleccion.add(new Integer(11));

		// MAPAS
		
		Map<String, String> diccionario = new HashMap<String, String>();
		
		// Añadir una entrada al mapa
		diccionario.put("Clave", "Valor");
		diccionario.put("Palabra", "Significado");
		diccionario.put("Clave", "OtroValor"); // misma clave, cambio su valor asociado
		diccionario.put("OtraClave", null); // clave con valor nulo
		// Tamaño
		diccionario.size();
		// Obtener valor asociado a una clave
		String valor = diccionario.get("Clave"); // devuelve "OtroValor"
		// Saber si una clave está en el mapa
		diccionario.containsKey("Clave"); // true
		diccionario.containsKey("Significado"); // false
		// Saber si un valor está asociado a alguna clave
		diccionario.containsValue("Clave"); // false
		diccionario.containsValue("Significado"); // true

	 	// Eliminar una entrada del mapa
		diccionario.remove("OtraClave");

		// Recorrer un mapa a partir de sus claves
		Set<String> claves = diccionario.keySet();
		for (String clave : claves) {
		  String val = diccionario.get(clave);
		  System.out.println(clave.toString() + " -> " + val.toString());
		}

		// Saber si un mapa está vacío o vaciarlo
		boolean vacio = diccionario.isEmpty(); // devolverá 'false'
		diccionario.clear(); // ahora sí que está vacía		
	}

}
