package es.ua.dlsi.prog3.frameworks.opsbinarias;
/**
 * Clase abstracta que representa un operador binario definido para un cierto tipo de operando (TipoOperando)
 * @author drizo
 **/
public abstract class Operador<TipoOperando extends IOperando> {
	/**
	 * Simbolo del operando
	 */
	String op;
	
	/**
	 * Obtiene el símbolo del operando de su argumento 's'
	 * @param s cadena que contiene el símbolo del operando
	 * @throws ExcepcionFramworkOps Si 's' no contiene un símbolo de operando válido
	 */
	public void lee(String s)  throws ExcepcionFramworkOps {
		 op = s;
	}
	
	/**
	 * Devuelve el símbolo del operando
	 */
	public String toString() {
		return op;
	}
	
	/**
	 * Realiza la operación binaria
	 * @param a primer operando
	 * @param b segundo operando
	 * @return resultado de la operación
	 * @throws ExcepcionFramworkOps si no se puede realizar la operación por algún motivo
	 */
	public abstract TipoOperando calcula(TipoOperando a, TipoOperando b) throws ExcepcionFramworkOps;

}
