package es.ua.dlsi.prog3.frameworks.opscjtos;


import java.util.Set;
import java.util.TreeSet;

import es.ua.dlsi.prog3.frameworks.opsbinarias.ExcepcionFramworkOps;
import es.ua.dlsi.prog3.frameworks.opsbinarias.IOperando;

/** Conjunto de cadenas (String)
 *  @author drizo
 **/
public class OperandoCjtoCads implements IOperando {
	/**
	 * el conjunto de cadenas
	 */
	Set<String> cjto;
	
	/**
	 * Getter
	 * @return el conjunto de cadenas
	 */
	public final Set<String> getCjto() {
		return cjto;
	}
	
	/**
	 * Constructor 
	 * @param valores conjunto de cadenas para este operando
	 */
	public OperandoCjtoCads(Set<String> valores) {
		this.cjto = valores;
	}
	
	/**
	 * Constuctor por defecto. Crea un conjunto de cadenas vacío.
	 */
	public OperandoCjtoCads() {
		this.cjto = new TreeSet<String>();
	}
	
	/**
	 * Lee el conjunto de cadenas, representado mediante una cadena de elementos separados por comas, ignorando los espacios en blanco entre elementos
	 * @param cadena contiene los elementos del conjunto separados por comas (,).
	 * @throws ExcepcionFramworkOps nunca
	 */
	@Override
	public void lee(String cadena) throws ExcepcionFramworkOps {
			String [] cads = cadena.split(",");
			for (String string : cads) {
				cjto.add(string.trim());
			}
	}
	
	/**
	 * Devuelve la representación como String del conjunto de cadenas
	 */
	public String toString() {
		return cjto.toString();
	}
}
