package es.ua.dlsi.prog3.frameworks.opsenteros;


import es.ua.dlsi.prog3.frameworks.opsbinarias.ExcepcionFramworkOps;
import es.ua.dlsi.prog3.frameworks.opsbinarias.Operador;

/**
 * Operador para enteros. Soporta la suma ('+') y la resta ('-')
 * de conjuntos.
 * @author drizo
 **/
public class OperadorEntero extends Operador<OperandoEntero> {

	/**
	 * Calcula la suma o resta de enteros, dependiendo del operador creado
	 * @throws ExcepcionFramworkOps si el operando es desconocido.
	 */
	@Override
	public OperandoEntero calcula(OperandoEntero a, OperandoEntero b)
			throws ExcepcionFramworkOps {
		if (toString().equals("+")) {
			return new OperandoEntero(a.getInt() + b.getInt());
		} else if (toString().equals("-")) {
			return new OperandoEntero(a.getInt() - b.getInt());
		} else {
			throw new ExcepcionFramworkOps("Operando inválido: " + toString());
		}
	}
}
