package es.ua.dlsi.prog3.frameworks.opsenteros;


import es.ua.dlsi.prog3.frameworks.opsbinarias.ExcepcionFramworkOps;
import es.ua.dlsi.prog3.frameworks.opsbinarias.IOperando;

/** Operando de tipo entero
 * @author drizo
 **/
public class OperandoEntero implements IOperando {
	/** 
	 * el entero
	 */
	int valor;
	
	/**
	 * Constructor
	 * @param valor valor del entero
	 */
	public OperandoEntero(int valor) {
		this.valor = valor;
	}
	
	/**
	 * Constructor por defecto (valor 0)
	 */
	public OperandoEntero() {
	}
	
	/**
	 * Lee el entero, representado mediante una cadena.
	 * @param cadena contiene el valor del entero
	 * @throws ExcepcionFramworkOps si no se puede convertir la cadena en entero
	 */
	@Override
	public void lee(String cadena) throws ExcepcionFramworkOps {
		try {
			valor = new Integer(cadena).intValue();
		} catch (NumberFormatException e) {
			throw new ExcepcionFramworkOps("Error leyendo el operador entero: " + e.getMessage());
		}
	}
	
	/**
	 * getter
	 * @return valor del entero
	 */
	public int getInt() {
		return valor;
	}
	
	/**
	 * Valor del entero en una cadena
	 */
	public String toString() {
		return new Integer(valor).toString();
	}
}
