package es.ua.dlsi.prog3.generics;

/**
 * Una clase genérica simple. Es una caja que guarda dentro un objeto.
 * @author pierre
 *
 * @param <T> El tipo de objeto que queremos guardar en esta caja
 */
public class Box<T> {

	/**
	 * El objeto
	 */
	private T t;

	/**
	 * Guarda un objeto en la caja.
	 * @param t el objeto a guardar
	 */
    public void set(T t) { this.t = t; }
    
    /**
     * Devuelve una referencia al objeto que hay en la caja.
     * @return
     */
    public T get() { return t; }
    
    /**
     * Programa principal
     * @param args no se usa
     */
    public static final void main(String[] args) {
    	// Una caja para guardar enteros
    	Box<Integer> integerBox = new Box<Integer>();
    	
    	// Lo mismo con JAVA >= 1.7
    	// El compilador infiere el tipo del argumento genérico en la llamada al constructor
    	Box<Integer> integerBox2 = new Box<>();

    	// WARNING: Box is a raw type of Box<T>
    	// No compile time type checking is performed on raw types (obviously)
    	Box integerBox3 = new Box();


    }
}

