/**
 * 
 */
package es.ua.dlsi.prog3.generics;

/**
 * Interfaz para definir una pila de elementos genérica
 * Los elementos se insertan en el tope de la pila
 * El último elemento en ser apilado es el primero en ser desapilado
 * Una pila es una estructura de datos LIFO: Last-In-First-Out 
 * @author pierre
 *
 */
public interface Pila<T> {
	/**
	 * Apila un elemento en la pila
	 * @param o elemento a apilar
	 */
	void apila(T o);
	
	/**
	 * Desapila el último elemento añadido a la pila. Si la pila está vacía, devuelve null
	 * @return el elemento desapilado
	 */
	T desapila();
	
	/**
	 * Devuelve el último elemento apilado (el 'tope' de la pila), sin desapilarlo
	 * @return el elemento que está en el 'tope' de la pila
	 */
	T tope();
	
	/**
	 * Devuelve el número de elementos que contiene la pila
	 * @return tamaño de la pila
	 */
	int size();
}
