package es.ua.dlsi.prog3.generics;

/**
 * PilaDeEnteros como subclase de una clase genérica
 * (comparar con es.ua.dlsi.prog3.inheritance.secure.PilaDeEnteros) 
 * @author pierre
 *
 */
public class PilaDeEnteros extends ArrayPila<Integer> {
	/**
	 * Constructor
	 */
	public PilaDeEnteros() {
		super();
	}
	
	@Override
	public Integer tope() {
		// Copia defensiva de un objeto que SÍ sabemos de qué clase es: Integer
		return new Integer( ((Integer)super.tope()) );		
		// ¡¡en realidad java.lang.Integer no tiene constructor de copia!! ¿¿¿???
	}
	
	/**
	 * Programa principal para probar la pila de enteros
	 * @param args no se usa
	 */
	public static final void main(String args[]) {
		PilaDeEnteros pint = new PilaDeEnteros();
		
		for (int i=1; i<10; i++)
			pint.apila(i);

		while (pint.size() > 0) {
			System.out.println("Tope: "+pint.tope());
			System.out.println("Desapilo: "+ pint.desapila());
		}
	}

}
