package es.ua.dlsi.prog3.generics.pair;

import es.ua.dlsi.prog3.generics.Box;

/**
 * Implementación genérica de un interfaz genérico
 * @author pierre
 *
 * @param <K> clave
 * @param <V> valor
 */
public class MyPair<K, V> implements Pair<K, V> {

    private K key;
    private V value;

	public MyPair(K key, V value) {
	    this.key = key;
	    this.value = value;
	}

	@Override
	public K getKey() { return key; }

	@Override
	public V getValue() { return value; }
	
	/**
	 * Programa principal donde se instancia de diversas formas la clase genérica MyPair.
	 * @param args no se usa
	 */
	public static final void main(String[] args) {
		
		// Fíjate en las diferencias entre estas dos instrucciones y las dos siguientes
		// ¿Puedes explicarlas?
		Pair<String, Integer> p1 = new MyPair<String, Integer>("Even", 8);
		Pair<String, String>  p2 = new MyPair<String, String>("hello", "world");

		MyPair<String, Integer> op1 = new MyPair<>("Even", 8);
		MyPair<String, String>  op2 = new MyPair<>("hello", "world");

		// Los argumentos de tipo se pueden anidar al instanciar los tipos genéricos, como aquí:
		MyPair<String, Box<Integer>> op = new MyPair<>("primes", new Box<Integer>());
		op.getValue().set(4); 
	}
}
