package es.ua.dlsi.prog3.generics.restricted;

/**
 * Demostración de parámetros de tipo acotados
 * en un método genérico
 * @author pierre
 *
 */
public class BoundedTypeGenericMethod {

	/**
	 * Método genérico con un parámetro de tipo T acotado
	 * El tipo que se use para ejecutar el método debe implementar el interfaz Comparable
	 * 
	 * El método cuenta el número de objetos en el array 'anArray' mayores que 'elem'
	 * @param anArray Un array de objetos de tipo T
	 * @param elem Objeto con el que comparar 
	 * @return número de elementos del array mayores que 'elem'
	 */
	public static <T extends Comparable<T>> int countGreaterThan(T[] anArray, T elem) {
	    int count = 0;
	    for (T e : anArray)
	        if (e.compareTo(elem) > 0)
	            ++count;
	    return count;
	}

	/**
	 * Programa principal
	 * @param args no se usa
	 */
	public static final void main(String[] args) {
		Integer a = 4;
		Integer v[] = { 1,2,3,4,5,6,7,8,9 };

		System .out.println(countGreaterThan(v, a));
		
	}


	
}
