package es.ua.dlsi.prog3.generics.restricted;

/**
 * Demostración de métodos genéricos con parámetros de tipo acotados dentro de una clase genérica
 * @author pierre
 *
 * @param <T> Un tipo cualquiera
 */
public class Box<T> {
	    private T t;          

	    public void set(T t) {
	        this.t = t;
	    }
	    public T get() {
	        return t;
	    }

	    
	    /**
	     * Método con Genericidad restringida / Parámetro de tipo acotado / Bounded type parameter
	     * @param u Un objeto cualquiera
	     */
	    public <U extends Number> void inspect(U u){
	        System.out.println("T: " + t.getClass().getName());
	        // Como sé que 'U' es al menos Number o una subclase de Number, puedo usar
	        // la interfaz de Number con 'u':
	        System.out.println("U: " + u.getClass().getName() + u.intValue()); 
	    }

	    /**
	     * Programa principal
	     * @param args no se usa
	     */
	    public static void main(String[] args) {
	        Box<Integer> integerBox = new Box<Integer>();
	        integerBox.set(new Integer(10));
	        integerBox.inspect(new Float(1.2)); // ok, Float extends Number
	     //   integerBox.inspect("some text"); // compiler error!
	    }

}
