package es.ua.dlsi.prog3.generics.restricted;
/**
 * Demostración de múltiples cotas en parámetros de tipo
 * La primera cota puede ser una clase o un interfaz, el resto sólo pueden ser interfaces
 * @author pierre
 *
 * @param <T> Un tipo que tiene que ser al menos un Box<Integer> e implementar el interfaz Comparable<Integer>
 */
public class MultiBounded<T extends Box<Integer> & Comparable<Integer>> {

	/**
	 * Constructor
	 * Guarda un entero en la 'caja' y lo compara con otro entero
	 * @param elem
	 */
	public MultiBounded(T caja) {
		caja.set(4); // sabemos que es un Box<Integer>
		Box<Integer> box = new Box<>();
		box.set(5); // otro Box<Integer>
		// sabemos que podemos comparar el contenido de la caja con un Integer.
		System.out.println(caja.compareTo(box.get())); 
	}

	/**
	 * Programa principal
	 * @param args no se usa
	 */
	public static final void main(String args[]) {
		// No puedo instanciar T con Box<Integer>, que no implementa Comparable<Integer>:
		// MultiBounded<Box<Integer>> mb = new MultiBounded<Box<Integer>>(new Box<>());
		// Le pasamos al constructor una caja cuyo contenido se puede comparar con un Integer:
		MultiBounded<ComparableBox<Integer>> mb = 
				new MultiBounded<ComparableBox<Integer>>(new ComparableBox<>());
	}
}
