package es.ua.dlsi.prog3.inheritance.implementation.simple;

import java.util.ArrayList;
import java.util.List;

public class Banco {

	private List<Cuenta> cuentas;
	public Banco() {
		cuentas = new ArrayList<Cuenta>();
	}
	
	private void addCuenta(Cuenta c) {
		if (c!= null)
			cuentas.add(c);
	}

	public void nuevaCuenta(String tit, double s, int edad) {
		if (edad<21) 
			addCuenta(new CuentaJoven(tit,edad,s,0.02));
		else
			addCuenta(new Cuenta(tit,s,0.01));
	}
	
	public void eliminaCuenta(String tit) {
		for (Cuenta c : cuentas) {
			if (c.getTitular().equals(tit)) {
				cuentas.remove(c);
				break;
			}
		}
	}
	
	public void abonarInteresMensual() {
		for (Cuenta c: cuentas) {
			c.abonarInteresMensual();
			System.out.println(c);
		}
		
	}
	public static void main(String[] args) {
		
		//----- Cuenta, CuentaJoven -----
		CuentaJoven tcj = new CuentaJoven("Viriato",21,1000,0.1);
		Cuenta c;

		c = (Cuenta)tcj; // explícito
		c = tcj; // implícito

		tcj.setEdad(18); //OK
		// c.setEdad(18); // ¡ERROR! ¿¿por qué??

		// Creamos un banco
		Banco banco = new Banco();
		
		banco.nuevaCuenta("Viriato Adulto",1000,21);
		banco.nuevaCuenta("Viriato Joven",10000,12);

		banco.abonarInteresMensual();
		
		banco.eliminaCuenta("Viriato Joven");
	
		banco.abonarInteresMensual();

		
	}

}
