package es.ua.dlsi.prog3.inheritance.implementation.simple;

public class Cuenta{
	  private String titular;
	  private double saldo;
	  protected double interes;

	  private static int numCuentas=0;

	  public Cuenta() 
	  { titular=""; saldo=0.0; interes=0.0; numCuentas++; }
	  
	  public Cuenta(String t, double s, double i)
	   { titular=t; saldo=s; interes=i; numCuentas++; } 

	  public Cuenta(Cuenta tc)
	  { titular=tc.titular; saldo=tc.saldo; interes=tc.interes; numCuentas++; }

	  protected void finalize() throws Throwable { numCuentas--; }
	  
	  void abonarInteresMensual()
	  { setSaldo(getSaldo()*(1+getInteres()/100/12)); }


	  public String toString ()
	  {
	    return "NumCuentas=" + Cuenta.numCuentas + "\n"
	      + "Titular=" + titular + "\n"
	      + "Saldo=" + saldo + "\n"
	      + "Interes=" + interes + "\n";
	  }

	public String getTitular() {
		return titular;
	}

	public void setTitular(String titular) {
		this.titular = titular;
	}

	public double getSaldo() {
		return saldo;
	}

	public void setSaldo(double saldo) {
		this.saldo = saldo;
	}

	public double getInteres() {
		return interes;
	}

	public void setInteres(double interes) {
		this.interes = interes;
	}
	
	public static void visualiza(Cuenta c) {
		System.out.println(c);
	}

}
