/**
 * Demonstración de herencia simple de interfaz
 */
package es.ua.dlsi.prog3.inheritance.interfaz;

/**
 * Par ordenado de objetos comparables
 * @author pierre
 *
 */
public class ParOrdenado  {
	  /**
	   * Un par de referencias a objetos que implementan Comparable.
	   * Usamos el comodín de tipo porque no sabemos de que tipo será el objeto, sólo
	   * que implementará la interfaz Comparable
	   * 
	   * El objeto menor lo alamacenaremos en la posición [0] y el otro en la [1].
	   */
	  private Comparable<?>[] par = new Comparable[2];
	  
	  public Comparable<?> getMenor() { return par[0]; }
	  public Comparable<?> getMayor() { return par[1]; }

	  // Implementa este constructor para que el código cliente de main() (más abajo) funcione
	  // como se espera
	  public ParOrdenado(Comparable<?> p1, Comparable<?> p2) {

	  }

	  // Codigo cliente
	  public static void main(String args[] ) {
		  ParOrdenado po = new ParOrdenado(new Entero(7), new Entero(3));
		  po.getMenor(); // 3
		  po.getMayor(); // 7
	  }
}



