/**
 * Demostración de varias formas de polimorfismo en herencia de implementación: 
 * upcasting, downcasting, enlace dinámico (sobrescritura)
 */
package es.ua.dlsi.prog3.inheritance.polymorphism;

/**
 * Programa con varios trozos de código ('Código cliente 1, 2, ...')
 * que ejemplifican varios casos de uso de la jerarquía de Persona
 * En algunos casos hay errores de compilación que debes entender bien porqué
 * se producen
 * @author pierre
 *
 */
public class CodigoCliente {

	public static void main(String[] args) {
		//Código cliente 1
		 
	    Empleado empleado = new Empleado("Carlos","Lavandería");
	    Persona pers = new Persona("Juan");

	    // El downcasting implícito no es posible:
	    empleado = pers;
	    System.out.println( empleado.getDatos() );

	    // Código cliente 2

	    empleado = null;
	    Estudiante estudiante = null;
	    pers = new Persona("José");
	    empleado = pers; // downcasting implícito
	    estudiante = pers; // downcasting implícito
	    System.out.println( empleado.getDatos() );
	    System.out.println(  estudiante.getDatos() );

	    // Código cliente 3

	    Empleado emp = new Empleado("Carlos", "lavanderia");
	    Estudiante est = new Estudiante("Juan","Derecho");
	    pers = emp;
	    System.out.println( emp.getDatos() );
	    System.out.println( est.getDatos() );
	    System.out.println( pers.getDatos() );

	    // Código cliente 4

	    Empleado uno= new Empleado("Carlos", "lavanderia");
	    Persona desc = uno;
	    // Para el compilador, 'desc' es una persona, no un empleado
	    System.out.println( desc.getEmpresa() );

	    // Código cliente 5

	    desc = new Persona("Carlos");
	    emp = (Empleado)desc;
	    System.out.println( emp.getEmpresa() );

	    // Código cliente 6

	    desc = new Persona("Carlos");
	    if (desc instanceof Empleado) {
	      emp = (Empleado)desc;
	      System.out.println( emp.getEmpresa() );
	    }

	    // Código cliente 7
	    // Haz que el método Persona.getDatos tenga enlace estático declarándolo como 'final'
	    // Luego comprueba que sucede con este código:
	    emp = new Empleado("Carlos", "lavanderia");
	    est = new Estudiante("Juan","Derecho");
	    pers = emp;
	    System.out.println( emp.getDatos() );
	    System.out.println( est.getDatos() );
	    System.out.println( pers.getDatos() );

	}

}
