/**
 * Demonstración de downcasting
 */
package es.ua.dlsi.prog3.inheritance.polymorphism.downcasting;

public class Downcasting {

	public static void main(String[] args) {
		
		// Visualiza o dibuja las referencias, objetos y objetos Class en memoria

		// Downcasting seguro usando Class directamente

		Animal a = new PastorBelga();
		if (a.getClass() == PastorBelga.class) // cierto 
		{ PastorBelga pb = (PastorBelga)a; }
		if (a.getClass() == Perro.class) // falso
		{ Perro p = (Perro)a; }

		// Downcasting seguro usando ‘instanceof’:

		a = new PastorBelga();
		if (a instanceof PastorBelga) // cierto 
		{ PastorBelga pb = (PastorBelga)a; } 
		if (a instanceof Perro) // cierto
		{ Perro p = (Perro)a; }

		//Downcasting seguro usando Class.isInstance():

		a = new Perro();
		Animal b = new PastorBelga();
		hacerLadrar(a, b);

	}

	/**
	 * Downcasting seguro usando Class.isInstance()
	 * @param a un animal
	 * @param b un animal
	 */
	public static void hacerLadrar(Animal a, Animal b) {
		Class<?> clasePerro = a.getClass();
		if (clasePerro.isInstance(b)) { //cierto
			Perro p = (Perro)b; // seguro
			p.ladrar();
		}
	}

}
