/**
 * Demostración de refactorización, basado en el ejemplo del capítulo 1 de 
 * 'Refactoring. Improving the Design of Existing Code', de Martin Fowler.
 * 
 * Código original sin refactorizar
 */
package es.ua.dlsi.prog3.refactoring.videoclub.original;

/**
 * Una película para alquilar. Representa la película, no una unidad de DVD en concreto.
 * 
 * Hay tres tipos de películas: infantiles, normales y de estreno.
 * 
 * Cada película tiene un título y un código de precio
 * 
 *
 */
public class Pelicula {

	public static final int INFANTIL=1;
	public static final int NORMAL=2;
	public static final int ESTRENO=3;

	private String titulo;
	private int codigoPrecio;
	
	public Pelicula(String tit, int cod) {	
	  titulo=tit;
	  codigoPrecio=cod;
	}

	
	/**
	 * @return the codigoPrecio
	 */
	public int getCodigoPrecio() {
		return codigoPrecio;
	}

	/**
	 * @param codigoPrecio the codigoPrecio to set
	 */
	public void setCodigoPrecio(int codigoPrecio) {
		this.codigoPrecio = codigoPrecio;
	}

	/**
	 * @return the titulo
	 */
	public String getTitulo() {
		return titulo;
	}
	

}
