/**
 * Demostración de refactorización, basado en el ejemplo del capítulo 1 de 
 * 'Refactoring. Improving the Design of Existing Code', de Martin Fowler.
 * 
 * Código refactorizado. Así debería quedar, más o menos, tu refactorización.
 */
package es.ua.dlsi.prog3.refactoring.videoclub.refactored;

public class Alquiler {

	private Pelicula pelicula;
	private int diasAlquiler;
	
	public Alquiler(Pelicula p, int dias) {
		pelicula=p;
		diasAlquiler=dias;
	}

	/**
	 * @return the pelicula
	 */
	public Pelicula getPelicula() {
		return pelicula;
	}

	/**
	 * @return the diasAlquiler
	 */
	public int getDiasAlquiler() {
		return diasAlquiler;
	}
	
	/**
	 * Obtiene el cargo a aplicar por el alquiler
	 * @return cargo por alquiler
	 */
	public double getCargoAlquiler() {
		
		return this.getPelicula().calculaCargoAlquiler(this);
	}

	/** Este método es fruto de la refactorizacion de Cliente.informe()
	 * @return
	 */
	public int getFrequentRenterPoints() {
		return getPelicula().getBonificacionAlquilerFrecuente(getDiasAlquiler());
	}
}
