/**
 * Demostración de refactorización, basado en el ejemplo del capítulo 1 de 
 * 'Refactoring. Improving the Design of Existing Code', de Martin Fowler.
 * 
 * Código refactorizado. Así debería quedar, más o menos, tu refactorización.
 */
package es.ua.dlsi.prog3.refactoring.videoclub.refactored;

abstract public class Pelicula {


	private String titulo;
	
	public Pelicula(String tit) {	
	  titulo=tit;
	}

	abstract public double getPrecio();
	abstract public int getMaxDiasAlquiler();
	
	/**
	 * @return the titulo
	 */
	public String getTitulo() {
		return titulo;
	}
	
	/**
	 * Es posible refactorizar aún este método, pasándole solo el número de días de alquiler,
	 * que es lo que se usa de Alquiler.
	 * @param a
	 * @return
	 */
	public double calculaCargoAlquiler(Alquiler a) {
		double cargo = 0.0;
		cargo = this.getPrecio();
		if (a.getDiasAlquiler() > this.getMaxDiasAlquiler()) 							
			cargo += (a.getDiasAlquiler() - this.getMaxDiasAlquiler()) * 1.5;
		return cargo;
	}
	
	/** 
	 * Refactorización de Alquiler.getFrequentRenterPoints
	 * @param diasAlquiler
	 * @return
	 */
	public int getBonificacionAlquilerFrecuente(int diasAlquiler) {
		return 1;
	}

}
