/**
 * Demostración de refactorización, basado en el ejemplo del capítulo 1 de 
 * 'Refactoring. Improving the Design of Existing Code', de Martin Fowler.
 * 
 * Código refactorizado. Así debería quedar, más o menos, tu refactorización.
 */
package es.ua.dlsi.prog3.refactoring.videoclub.refactored;

public class PeliculaEstreno extends Pelicula {

	public PeliculaEstreno(String tit) {
		super(tit);
	}

	@Override
	public double getPrecio() {
		return 3;
	}

	@Override
	public int getMaxDiasAlquiler() {
		return 0;
	}

	@Override
	public double calculaCargoAlquiler(Alquiler a) {
		return a.getDiasAlquiler() * this.getPrecio();
	}
	
	@Override
	public int getBonificacionAlquilerFrecuente(int diasAlquiler) {
		// add bonus for a two day new release rental
		return (diasAlquiler > 1) ? 2 : 1;

	}

}
