package es.ua.dlsi.prog3.reflection;
import java.lang.reflect.Array;

/**
 * La clase Array
 * 
 * Demostración de como crear un array por reflexión
 * 
 * @author Pedro J. Ponce de León
 * @version 0.1
 */

  class Perro {
    String raza;
    Perro(String r) { raza=r; }
    public String toString() { return raza; }
  }

public class T20
{
  
    public static void main(String args[]) throws ClassNotFoundException {
        
        // T20 Construcción normal de un array 
         //Perro[] perrera = new Perro[10];
        
        // T21 Construcción de un array mediante reflexión
        Class c = Class.forName( "Perro" );
        Object perrera = (Object[]) Array.newInstance( c, 10 );
        
        int n = Array.getLength( perrera );
        // asigna uno de los elementos del array
        Array.set( perrera, (n-1), new Perro( "Spaniel" ) );
        
        // Obtiene un objeto del array, determina su clase y muestra su valor:
        Object obj = Array.get( perrera, (n-1) );
        Class c1 = obj.getClass( );     
        System.out.println( c1.getName( ) + "-->" 
            + obj.toString( ) );
    }
}
