package es.ua.dlsi.prog3.reflection;
import java.lang.reflect.Array;
/**
 * Demostración de como copiar correctamente un array por reflexión
 * 
 */
public class T23_25
{


    // Este código no funcionará 
    public static Object[] doubleArrayBad( Object[] arr )
    {
        int newSize = arr.length * 2 + 1;
        
        Object[] newArray = new Object[ newSize ];
        
        for( int i = 0; i < arr.length; i++ )
            newArray[ i ] = arr[ i ];
            
        return newArray;
    }

    public static Object[] doubleArray( Object[] arr )
    {
        Class c1 = arr.getClass( );     
        if( !c1.isArray( ) ) return null;
        
        int oldSize = Array.getLength( arr );
        int newSize = oldSize * 2 + 1;
        
        Object[] newArray = (Object[]) Array.newInstance(
            c1.getComponentType( ), newSize );
    
        for( int i = 0; i < arr.length; i++ )
            newArray[ i ] = arr[ i ];
                
        return newArray;
    }
    
    static void printArray(Object[] array) {
      System.out.println("Doble array (length: "+array.length+")");
      for (Object obj : array)
        System.out.print(obj+", ");
      System.out.println();
    }
    
    public static void main(String args[]) {
      Integer[] array = new Integer[] { 1,2,3,4,5 };
      
      Object[] darray = doubleArrayBad(array);
      
      System.out.println("Tipo base doble array (Bad): "+darray.getClass().getName());
      System.out.println("Tipo base componente doble array (Ok): "+darray[0].getClass().getName());

      Object[] darray2 = doubleArray(array);
      
      System.out.println("Tipo base doble array (Ok): "+darray2.getClass().getName());
      System.out.println("Tipo base componente doble array (Ok): "+darray2[0].getClass().getName());

      printArray(darray);
      System.out.println();
      printArray(darray2);
    }
}
