package es.ua.dlsi.prog3.reflection;
import java.lang.reflect.*;

/**
 * Demostración de cómo invocar a un método estático por reflexión
 * Este código ejecuta main() dos veces (la segunda, mediante reflexión)
 * 
 */
public class T33
{

  static boolean mainAlreadyCalled=false;

static void callMainAgain() throws 
ClassNotFoundException, NoSuchMethodException, IllegalAccessException, InvocationTargetException {
    
    Class cl = Class.forName( "T20" );
    Class[] paramTypes = new Class[] { String[].class };
    Method m = cl.getDeclaredMethod( "main", paramTypes );
    Object[] args = new Object[] 
        { new String[] { "Breathing", "Fire" } };
    
    mainAlreadyCalled = true;
    m.invoke( null, args );

}

public static void main(String args[]) {

  
  System.out.print("Argumentos de main: ");
  for (String s : args)
    System.out.print(s+" ");
  System.out.println();
  
    try {
    if (!mainAlreadyCalled)
        callMainAgain();
    } catch (Exception ex) {
        ex.printStackTrace();
    }
}

}
