package es.ua.dlsi.prog3.reflection;
import java.lang.reflect.*;

/**
 * Demostración de cómo encontrar un método en una jerarquía de herencia
 * 
 */
public class T47
{
    public static Method findMethod(Class<?> cls, String methodName, Class<?>[] paramTypes)
    {
        Method method = null; 
        while (cls != null) {
        try { 
            method = cls.getDeclaredMethod(methodName, 
                        paramTypes);
            break;
        }
        catch (NoSuchMethodException ex) {
            cls = cls.getSuperclass();
        }
        }
        return method;
        
    }

    public static void main(String args[]) throws ClassNotFoundException {
        
      Method m = findMethod(Class.forName("es.ua.dlsi.prog3.reflection.T47"), "equals", new Class[] { Object.class } );
      if (m!=null)
        System.out.println("Metodo "+m.getName()+ " declarado en "+m.getDeclaringClass());
    }
}
